#include "init.h"

void
swf_no_fill()
{
	rb_raise(rb_eRuntimeError, "already closed fill");
}

static void
swf_free_fill(p)
	SWFFill p;
{
	Debug("swf free fill");
	destroySWFFill(p);
}

VALUE
swf_fill_alloc(self, p)
	VALUE self;
	SWFFill p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_fill_rotate_to(self, degrees)
	VALUE self, degrees;
{
	SWFFill p;
	
	GetFill(self, p);
	SWFFill_rotateTo(p, NUM2DBL(degrees));
	return Qnil;
}

static VALUE
swf_fill_move_to(self, x, y)
	VALUE self, x, y;
{
	SWFFill p;
	
	GetFill(self, p);
	SWFFill_moveTo(p, NUM2INT(x), NUM2INT(y));
	return Qnil;
}

static VALUE
swf_fill_scale_to(self, x, y)
	VALUE self, x, y;
{
	SWFFill p;
	
	GetFill(self, p);
	SWFFill_scaleXYTo(p, NUM2DBL(x), NUM2DBL(y));
	return Qnil;
}

static VALUE
swf_fill_skew_x_to(self, x)
	VALUE self, x;
{
	SWFFill p;
	
	GetFill(self, p);
	SWFFill_skewXTo(p, NUM2DBL(x));
	return Qnil;
}

static VALUE
swf_fill_skew_y_to(self, y)
	VALUE self, y;
{
	SWFFill p;
	
	GetFill(self, p);
	SWFFill_skewYTo(p, NUM2DBL(y));
	return Qnil;
}

void
swf_init_fill()
{
	cSwf_fill = rb_define_class_under(mSwf, "Fill", rb_cObject);
	rb_define_method(cSwf_fill, "rotate_to", swf_fill_rotate_to, 1);
	rb_define_method(cSwf_fill, "move_to", swf_fill_move_to, 2);
	rb_define_method(cSwf_fill, "scale_to", swf_fill_scale_to, 2);
	rb_define_method(cSwf_fill, "skew_x_to", swf_fill_skew_x_to, 1);
	rb_define_method(cSwf_fill, "skew_y_to", swf_fill_skew_y_to, 1);
	
	rb_define_const(cSwf_fill, "SOLID", INT2FIX(SWFFILL_SOLID));
	rb_define_const(cSwf_fill, "GRADIENT", INT2FIX(SWFFILL_GRADIENT));
	rb_define_const(cSwf_fill, "LINEAR_GRADIENT", INT2FIX(SWFFILL_LINEAR_GRADIENT));
	rb_define_const(cSwf_fill, "RADIAL_GRADIENT", INT2FIX(SWFFILL_RADIAL_GRADIENT));
	rb_define_const(cSwf_fill, "BITMAP", INT2FIX(SWFFILL_BITMAP));
	rb_define_const(cSwf_fill, "TILED_BITMAP", INT2FIX(SWFFILL_TILED_BITMAP));
	rb_define_const(cSwf_fill, "CLIPPED_BITMAP", INT2FIX(SWFFILL_CLIPPED_BITMAP));
}
