#include "init.h"

void
swf_no_MovieClip()
{
	rb_raise(rb_eRuntimeError, "already closed MovieClip");
}

static void
swf_free_MovieClip(p)
	SWFMovieClip p;
{
	Debug("swf free MovieClip");
	destroySWFMovieClip(p);
}

static VALUE
swf_MovieClip_new(self)
	VALUE self;
{
	VALUE obj;
	SWFMovieClip p;
	
	p = newSWFMovieClip();
	obj = Data_Wrap_Struct(self, 0, swf_free_MovieClip, p);
	return obj;
}
/*
static VALUE
swf_MovieClip_get_frames(self)
	VALUE self;
{
	SWFMovieClip p;
	
	GetMovieClip(self, p);
	return INT2FIX(p->totalFrames);
}
*/
static VALUE
swf_MovieClip_set_frames(self, v)
	VALUE self, v;
{
	SWFMovieClip p;
	
	GetMovieClip(self, p);
	SWFMovieClip_setNumberOfFrames(p, NUM2INT(v));
	return v;
}

static VALUE
swf_MovieClip_add(self, v)
	VALUE self, v;
{
	SWFMovieClip p;
	SWFBlock p_block;
	SWFDisplayItem item;
	
	GetMovieClip(self, p);
	GetBlock(v, p_block);
	RDATA(v)->dfree = NULL;
	item = SWFMovieClip_add(p, p_block);
	return swf_DisplayItem_alloc(cSwf_DisplayItem, item);
}

static VALUE
swf_MovieClip_remove(self, v)
	VALUE self, v;
{
	SWFMovieClip p;
	t_DisplayItem *dip;
	
	GetMovieClip(self, p);
	GetDisplayItem(v, dip);
	SWFMovieClip_remove(p, dip->real);
	return Qnil;
}

static VALUE
swf_MovieClip_next_frame(self)
	VALUE self;
{
	SWFMovieClip p;
	FILE* file;
	const char* fname;
	
	GetMovieClip(self, p);
	SWFMovieClip_nextFrame(p);
	return Qnil;
}

static VALUE
swf_MovieClip_set_frame_name(self, v)
	VALUE self, v;
{
	SWFMovieClip p;
	
	GetMovieClip(self, p);
	SWFMovieClip_labelFrame(p, STR2CSTR(v));
	return Qnil;
}

void
swf_init_MovieClip()
{
	cSwf_MovieClip = rb_define_class_under(mSwf, "MovieClip", rb_cObject);
	rb_define_singleton_method(cSwf_MovieClip, "new", swf_MovieClip_new, 0);
//	DefineAttr(cSwf_MovieClip, frames)
	rb_define_method(cSwf_MovieClip, "frames=", swf_MovieClip_set_frames, 1);
	rb_define_method(cSwf_MovieClip, "add", swf_MovieClip_add, 1);
	rb_define_method(cSwf_MovieClip, "remove", swf_MovieClip_remove, 1);
	rb_define_method(cSwf_MovieClip, "next_frame", swf_MovieClip_next_frame, 0);
	rb_define_method(cSwf_MovieClip, "frame_name=", swf_MovieClip_set_frame_name, 1);
}
